#include <iostream>
#include <vector>
#include <string>

#include "marci_list_graph.hh"
#include "marci_graph_traits.hh"
#include "marci_property_vector.hh"
#include "preflow_push.hh"

using namespace marci;


int main (int, char*[])
{
  typedef graph_traits<list_graph>::node_iterator node_iterator;
  typedef graph_traits<list_graph>::edge_iterator edge_iterator;
  typedef graph_traits<list_graph>::each_node_iterator each_node_iterator;
  typedef graph_traits<list_graph>::each_edge_iterator each_edge_iterator;
  typedef graph_traits<list_graph>::out_edge_iterator out_edge_iterator;
  typedef graph_traits<list_graph>::in_edge_iterator in_edge_iterator;
  typedef graph_traits<list_graph>::sym_edge_iterator sym_edge_iterator;

  list_graph flow_test;
 
  
  //Ahuja knyv pldja
  node_iterator s=flow_test.add_node();
  node_iterator v2=flow_test.add_node();
  node_iterator v3=flow_test.add_node();
  node_iterator v4=flow_test.add_node();
  node_iterator v5=flow_test.add_node();
  node_iterator t=flow_test.add_node();
  
  node_property_vector<list_graph, std::string> node_name(flow_test);
  node_name.put(s, "s");  
  node_name.put(v2, "v2");
  node_name.put(v3, "v3");
  node_name.put(v4, "v4");
  node_name.put(v5, "v5");
  node_name.put(t, "t");

  
  edge_iterator s_v2=flow_test.add_edge(s, v2);
  edge_iterator s_v3=flow_test.add_edge(s, v3);
  
  edge_iterator v2_v4=flow_test.add_edge(v2, v4);
  edge_iterator v2_v5=flow_test.add_edge(v2, v5);

  edge_iterator v3_v5=flow_test.add_edge(v3, v5);

  edge_iterator v4_t=flow_test.add_edge(v4, t);
  edge_iterator v5_t=flow_test.add_edge(v5, t);
  
  //Kis modositas
  edge_iterator v2_s=flow_test.add_edge(v2, s);

  edge_property_vector<list_graph, int> cap(flow_test);  
  cap.put(s_v2, 10);
  cap.put(s_v3, 10);
  cap.put(v2_v4, 5);
  cap.put(v2_v5, 8);
  cap.put(v3_v5, 5);
  cap.put(v4_t, 8);
  cap.put(v5_t, 8);

  //Kis modositas
  cap.put(v2_s, 100);

  //Kis modositas
  //edge_iterator t_s=flow_test.add_edge(t, s);
  //cap.put(t_s, 20);

  
  /*
  //Marci pldja
  node_iterator s=flow_test.add_node();
  node_iterator v1=flow_test.add_node();
  node_iterator v2=flow_test.add_node();
  node_iterator v3=flow_test.add_node();
  node_iterator v4=flow_test.add_node();
  node_iterator t=flow_test.add_node();
  
  node_property_vector<list_graph, std::string> node_name(flow_test);
  node_name.put(s, "s");
  node_name.put(v1, "v1");
  node_name.put(v2, "v2");
  node_name.put(v3, "v3");
  node_name.put(v4, "v4");
  node_name.put(t, "t");

  edge_iterator s_v1=flow_test.add_edge(s, v1);
  edge_iterator s_v2=flow_test.add_edge(s, v2);
  edge_iterator v1_v2=flow_test.add_edge(v1, v2);
  edge_iterator v2_v1=flow_test.add_edge(v2, v1);
  edge_iterator v1_v3=flow_test.add_edge(v1, v3);
  edge_iterator v3_v2=flow_test.add_edge(v3, v2);
  edge_iterator v2_v4=flow_test.add_edge(v2, v4);
  edge_iterator v4_v3=flow_test.add_edge(v4, v3);
  edge_iterator v3_t=flow_test.add_edge(v3, t);
  edge_iterator v4_t=flow_test.add_edge(v4, t);
  
  edge_property_vector<list_graph, int> cap(flow_test);  
  cap.put(s_v1, 16);
  cap.put(s_v2, 13);
  cap.put(v1_v2, 10);
  cap.put(v2_v1, 4);
  cap.put(v1_v3, 12);
  cap.put(v3_v2, 9);
  cap.put(v2_v4, 14);
  cap.put(v4_v3, 7);
  cap.put(v3_t, 20);
  cap.put(v4_t, 4);
  */ 
  /*Egyszer plda
  node_iterator s=flow_test.add_node();
  node_iterator v1=flow_test.add_node();
  node_iterator v2=flow_test.add_node();
  node_iterator t=flow_test.add_node();
  
  node_property_vector<list_graph, std::string> node_name(flow_test);
  node_name.put(s, "s");
  node_name.put(v1, "v1");
  node_name.put(v2, "v2");
  node_name.put(t, "t");

  edge_iterator s_v1=flow_test.add_edge(s, v1);
  edge_iterator v1_v2=flow_test.add_edge(v1, v2);
  edge_iterator v2_t=flow_test.add_edge(v2, t);

  edge_property_vector<list_graph, int> cap(flow_test); 
    
  cap.put(s_v1, 16);
  cap.put(v1_v2, 10);
  cap.put(v2_t, 4);
  */

  std::cout << "preflow-push algorithm test..." << std::endl;
  std::cout << "on directed graph graph" << std::endl; //<< flow_test;
  std::cout << "names and capacity values" << std::endl; 
  for(each_node_iterator i=flow_test.first_node(); i.valid(); ++i) { 
    std::cout << node_name.get(i) << ": ";
    std::cout << "out edges: ";
    for(out_edge_iterator j=flow_test.first_out_edge(i); j.valid(); ++j) 
      std::cout << node_name.get(flow_test.tail(j)) << "-"<< cap.get(j) << "->" << node_name.get(flow_test.head(j)) << " ";
    std::cout << "in edges: ";
    for(in_edge_iterator j=flow_test.first_in_edge(i); j.valid(); ++j) 
      std::cout << node_name.get(flow_test.tail(j)) << "-"<< cap.get(j) << "->" << node_name.get(flow_test.head(j)) << " ";
    std::cout << std::endl;
  }

  
  //for(each_node_iterator i=flow_test.first_node(); i.valid(); ++i) { 
  //  std::cout << i << " ";
  //}
  
  preflow_push<list_graph, int> preflow_push_test(flow_test, s, t, cap);
  cout << preflow_push_test.run()<<endl;

  //cap.put(v5_t, 9);
  //cout << preflow_push_test.run()<<endl;

  return 0;
}









